#include <gtk/gtk.h>

#define WIDTH 320
#define HEIGHT 240

gboolean draw (GtkWidget *widget, cairo_t *c, gpointer data)
{
  GdkRGBA red = { 1.0, 0.0, 0.0, 0.8 };
  GdkRGBA yellow = { 1.0, 1.0, 0.0, 0.6 };
  GdkRGBA blue = { 0.0, 0.5, 1.0, 0.4 };

  gdk_cairo_set_source_rgba (c, &red);
  cairo_rectangle (c, 10, 10, 60, 40);
  cairo_fill (c);

  gdk_cairo_set_source_rgba (c, &yellow);
  cairo_arc (c, 65, 50, 30, 0, 2 * G_PI);
  cairo_fill (c);

  gdk_cairo_set_source_rgba (c, &blue);
  cairo_move_to (c, 10, 70);
  cairo_line_to (c, 70, 70);
  cairo_line_to (c, 40, 18);
  cairo_close_path (c);
  cairo_fill (c);

  return FALSE;  /* TRUE to stop other handlers from being invoked for the event.
                    FALSE to propagate the event further. */
}

int main (int argc, char **argv)
{
  gtk_init (&argc, &argv);

  GtkWidget *window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_show (window);
  gtk_window_set_title (GTK_WINDOW (window), "Hello");

  GtkWidget *drawing_area = gtk_drawing_area_new ();
  gtk_widget_show (drawing_area);
  gtk_container_add (GTK_CONTAINER (window), drawing_area);
  gtk_widget_set_size_request (drawing_area, WIDTH, HEIGHT);
  g_signal_connect (drawing_area, "draw", G_CALLBACK (draw), NULL);
  g_signal_connect (drawing_area, "clicked", G_CALLBACK (gtk_main_quit), NULL);

  gtk_main ();
  return 0;
}
