#include <stdio.h>
#include <stdlib.h>

typedef struct node
{
  int content_left, content_right;
  struct node *left, *middle, *right;
} node;

void insert_into_tree (node **root, int value)
{
  if (*root)
    {
      if ((*root)->content_right >= 0)
        if (value < (*root)->content_left)
          insert_into_tree (&(*root)->left, value);
        else if (value < (*root)->content_right)
          insert_into_tree (&(*root)->middle, value);
        else
          insert_into_tree (&(*root)->right, value);
      else
        if (value < (*root)->content_left)
          {
            (*root)->content_right = (*root)->content_left;
            (*root)->content_left = value;
          }
        else
          (*root)->content_right = value;
    }
  else
    {
      *root = malloc (sizeof (node));
      (*root)->left = NULL;
      (*root)->content_left = value;
      (*root)->middle = NULL;
      (*root)->content_right = -1;
      (*root)->right = NULL;
    }
}

void output_tree (node *root)
{
  if (root)
    {
      output_tree (root->left);
      printf ("%d\n", root->content_left);
      output_tree (root->middle);
      if (root->content_right >= 0)
        printf ("%d\n", root->content_right);
      output_tree (root->right);
    }
}

int main (void)
{
  node *root = NULL;
  insert_into_tree (&root, 7);
  insert_into_tree (&root, 137);
  insert_into_tree (&root, 3);
  insert_into_tree (&root, 5);
  insert_into_tree (&root, 6);
  insert_into_tree (&root, 42);
  insert_into_tree (&root, 1);
  insert_into_tree (&root, 2);
  insert_into_tree (&root, 12);
  output_tree (root);
  return 0;
}
